/*
 * TestFindMaxSeq.h
 *
  *  Created on: Nov 25, 2013
 *		Author Wen-Hong Chiang
 */

#include <iostream>
#include <cppunit/TestFixture.h>
#include <cppunit/TestAssert.h>
#include <cppunit/TestCaller.h>
#include <cppunit/TestSuite.h>
#include <cppunit/TestCase.h>

#include "findmost.h"

using namespace std;

class TestFindMaxSeq : public CppUnit::TestFixture {
private:
	findmost fm;
public:
	TestFindMaxSeq(){}

	static CppUnit::Test *suite() {
		CppUnit::TestSuite *suiteOfTests = new CppUnit::TestSuite("TestFindMaxSeq");

		suiteOfTests->addTest(new CppUnit::TestCaller<TestFindMaxSeq>("Test1 - Unique Solution.",
				&TestFindMaxSeq::testFindMaxSeq_UniqueSolution ));

		suiteOfTests->addTest(new CppUnit::TestCaller<TestFindMaxSeq>("Test2 - Multiple Solutions.",
				&TestFindMaxSeq::testFindMaxSeq_MultipleSolutions ));

		suiteOfTests->addTest(new CppUnit::TestCaller<TestFindMaxSeq>("Test3 - All Solutions.",
				&TestFindMaxSeq::testFindMaxSeq_AllSolutions ));
				
		suiteOfTests->addTest(new CppUnit::TestCaller<TestFindMaxSeq>("Test4 - Negative Integers",
				&TestFindMaxSeq::testFindMaxSeq_NegativeIntegers ));

		return suiteOfTests;
	}

	/// Setup method
	void setUp() {}

	/// Teardown method
	void tearDown() {}

protected:
	void testFindMaxSeq_UniqueSolution() {
		int arr[9] = {9,8,7,7,7,5,3,2,1};
		int expected[9] = {7,0,0,0,0,0,0,0,0};
		int p[9];
		int index;
		fm.find_max_seq(arr,9,p,&index);
		for(int i=0;i<index;i++){
			CPPUNIT_ASSERT(p[i]==expected[i]);
		}

	}

	void testFindMaxSeq_MultipleSolutions() {
		int arr[9] = {9,8,8,7,7,4,4,3,1};
		int expected[9] = {8,7,4};
		int p[9];
		int index;
		fm.find_max_seq(arr,9,p,&index);
		for(int i=0;i<index;i++){
			CPPUNIT_ASSERT(p[i]==expected[i]);
		}
	}

	void testFindMaxSeq_AllSolutions() {
		int arr[9] = {3,3,3,3,3,3,3,3,3};
		int expected[9] = {3,0,0,0,0,0,0,0,0};
		int p[9];
		int index;
		fm.find_max_seq(arr,9,p,&index);
		for(int i=0;i<index;i++){
			CPPUNIT_ASSERT(p[i]==expected[i]);
		}
	}
	
	void testFindMaxSeq_NegativeIntegers() {
		int arr[9] = {9,6,3,1,-1,-1,-1,-4,-7};
		int expected[9] = {-1,0,0,0,0,0,0,0,0};
		int p[9];
		int index;
		fm.find_max_seq(arr,9,p,&index);
		for(int i=0;i<index;i++){
			CPPUNIT_ASSERT(p[i]==expected[i]);
		}
	}


};
