/*
 * TestQuickSort.h
 *
  *  Created on: Nov 25, 2013
 *		Author Wen-Hong Chiang 
 */

#include <iostream>
#include <cppunit/TestFixture.h>
#include <cppunit/TestAssert.h>
#include <cppunit/TestCaller.h>
#include <cppunit/TestSuite.h>
#include <cppunit/TestCase.h>

#include "findmost.h"

using namespace std;

class TestQuickSort : public CppUnit::TestFixture {
private:
	findmost fm;
public:
	TestQuickSort(){
			}

	static CppUnit::Test *suite() {
		CppUnit::TestSuite *suiteOfTests = new CppUnit::TestSuite("TestQuickSort");

		suiteOfTests->addTest(new CppUnit::TestCaller<TestQuickSort>("Test1 - Mutiple.",
				&TestQuickSort::testQuickSort_Multiple ));

		suiteOfTests->addTest(new CppUnit::TestCaller<TestQuickSort>("Test2 - Negative.",
				&TestQuickSort::testQuickSort_Negative ));

		suiteOfTests->addTest(new CppUnit::TestCaller<TestQuickSort>("Test3 - Odd Length.",
				&TestQuickSort::testQuickSort_Odd_Length ));

		suiteOfTests->addTest(new CppUnit::TestCaller<TestQuickSort>("Test4 - Even Length.",
				&TestQuickSort::testQuickSort_Even_Length ));


		return suiteOfTests;
	}

	/// Setup method
	void setUp() {}

	/// Teardown method
	void tearDown() {}

protected:
	void testQuickSort_Multiple() {
		int arr[9] = {9,7,15,7,3,7,1,9,5};
		int expected[9] = {15,9,9,7,7,7,5,3,1};
		fm.quick_sort(arr,9,0,8);
		for(int i=0;i<9;i++){
			CPPUNIT_ASSERT(arr[i]==expected[i]);
		}
	}
	
	void testQuickSort_Negative() {
		int arr[9] = {9,-7,15,7,3,17,-1,-9,5};
		int expected[9] = {17,15,9,7,5,3,-1,-7,-9};
		fm.quick_sort(arr,9,0,8);
		for(int i=0;i<9;i++){
			CPPUNIT_ASSERT(arr[i]==expected[i]);
		}
	}

	void testQuickSort_Odd_Length() {
		int arr[9] = {9,7,15,6,3,17,1,19,5};
		int expected[9] = {19,17,15,9,7,6,5,3,1};
		fm.quick_sort(arr,9,0,8);
		for(int i=0;i<9;i++){
			CPPUNIT_ASSERT(arr[i]==expected[i]);
		}
	}

	void testQuickSort_Even_Length() {
		int arr[10] = {2,9,7,15,6,3,17,1,19,5};
		int expected[10] = {19,17,15,9,7,6,5,3,2,1};
		fm.quick_sort(arr,10,0,9);
		for(int i=0;i<10;i++){
			CPPUNIT_ASSERT(arr[i]==expected[i]);
		}
	}
};
